package discrete;

import integratedtoolkit.types.annotations.Constraints;
import integratedtoolkit.types.annotations.Method;
import integratedtoolkit.types.annotations.Parameter;
import integratedtoolkit.types.annotations.Parameter.Direction;
import integratedtoolkit.types.annotations.Parameter.Type;

public interface DiscreteItf {

	@Method(declaringClass = "discrete.DiscreteImpl")
	@Constraints(processorCPUCount = 1, memoryPhysicalSize = 1.5f)
	void genReceptorLigand(@Parameter(type = Type.FILE, direction = Direction.IN) String pdbFile,
			@Parameter(type = Type.STRING, direction = Direction.IN) String binDir,
			@Parameter(type = Type.FILE, direction = Direction.OUT) String recFile,
			@Parameter(type = Type.FILE, direction = Direction.OUT) String ligFile);

	@Method(declaringClass = "discrete.DiscreteImpl")
	@Constraints(processorCPUCount = 1, memoryPhysicalSize = 1.5f)
	void dmdSetup(@Parameter(type = Type.FILE, direction = Direction.IN) String recFile,
			@Parameter(type = Type.FILE, direction = Direction.IN) String ligFile,
			@Parameter(type = Type.STRING, direction = Direction.IN) String binDir,
			@Parameter(type = Type.STRING, direction = Direction.IN) String dataDir,
			@Parameter(type = Type.FILE, direction = Direction.OUT) String topFile,
			@Parameter(type = Type.FILE, direction = Direction.OUT) String crdFile);

	@Method(declaringClass = "discrete.DiscreteImpl")
	@Constraints(processorCPUCount = 1, memoryPhysicalSize = 1.5f)
	void simulate(@Parameter(type = Type.FILE, direction = Direction.IN) String paramFile,
			@Parameter(type = Type.FILE, direction = Direction.IN) String topFile,
			@Parameter(type = Type.FILE, direction = Direction.IN) String crdFile,
			@Parameter(type = Type.STRING, direction = Direction.IN) String natom,
			@Parameter(type = Type.STRING, direction = Direction.IN) String binDir,
			@Parameter(type = Type.STRING, direction = Direction.IN) String dataDir,
			@Parameter(type = Type.FILE, direction = Direction.OUT) String averageFile);

	// TODO Define merge method

	@Method(declaringClass = "discrete.DiscreteImpl")
	@Constraints(processorCPUCount = 1, memoryPhysicalSize = 1.5f)
	void evaluate(@Parameter(type = Type.FILE, direction = Direction.IN) String averageFile,
			@Parameter(type = Type.FILE, direction = Direction.IN) String pydockFile,
			@Parameter(type = Type.DOUBLE, direction = Direction.IN) double fvdw,
			@Parameter(type = Type.DOUBLE, direction = Direction.IN) double fsolv,
			@Parameter(type = Type.DOUBLE, direction = Direction.IN) double eps,
			@Parameter(type = Type.FILE, direction = Direction.OUT) String scoreFile,
			@Parameter(type = Type.FILE, direction = Direction.OUT) String coeffFile

	);

	@Method(declaringClass = "discrete.DiscreteImpl")
	@Constraints(processorCPUCount = 1, memoryPhysicalSize = 1.5f)
	void min(@Parameter(type = Type.FILE, direction = Direction.INOUT) String f1,
			@Parameter(type = Type.FILE, direction = Direction.IN) String f2);
}
